## dahdi-linux 2.2.0.2~dfsg

=== Makefile ===
#
# Makefile for DAHDI Linux kernel modules
#
# Copyright (C) 2001-2009 Digium, Inc.
#
#

PWD:=$(shell pwd)

DAHDI_MODULES_EXTRA:=$(MODULES_EXTRA:%=%.o) $(SUBDIRS_EXTRA:%=%/)

# If you want to build for a kernel other than the current kernel, set KVERS
ifndef KVERS
KVERS:=$(shell uname -r)
endif
ifndef KSRC
  ifneq (,$(wildcard /lib/modules/$(KVERS)/build))
    KSRC:=/lib/modules/$(KVERS)/build
  else
    KSRC_SEARCH_PATH:=/usr/src/linux
    KSRC:=$(shell for dir in $(KSRC_SEARCH_PATH); do if [ -d $$dir ]; then echo $$dir; break; fi; done)
  endif
endif
KVERS_MAJ:=$(shell echo $(KVERS) | cut -d. -f1-2)
KINCLUDES:=$(KSRC)/include

# We use the kernel's .config file as an indication that the KSRC
# directory is indeed a valid and configured kernel source (or partial
# source) directory.
#
# We also source it, as it has the format of Makefile variables list.
# Thus we will have many CONFIG_* variables from there.
KCONFIG:=$(KSRC)/.config
ifneq (,$(wildcard $(KCONFIG)))
  HAS_KSRC:=yes
  include $(KCONFIG)
else
  HAS_KSRC:=no
endif

# Set HOTPLUG_FIRMWARE=no to override automatic building with hotplug support
# if it is enabled in the kernel.

ifeq (yes,$(HAS_KSRC))
  HOTPLUG_FIRMWARE:=$(shell if grep -q '^CONFIG_FW_LOADER=[ym]' $(KCONFIG); then echo "yes"; else echo "no"; fi)
endif

MODULE_ALIASES:=wcfxs wctdm8xxp wct2xxp

INST_HEADERS:=kernel.h user.h fasthdlc.h wctdm_user.h dahdi_config.h

DAHDI_BUILD_ALL:=m

KMAKE=$(MAKE) -C $(KSRC) SUBDIRS=$(PWD)/drivers/dahdi DAHDI_INCLUDE=$(PWD)/include DAHDI_MODULES_EXTRA="$(DAHDI_MODULES_EXTRA)" HOTPLUG_FIRMWARE=$(HOTPLUG_FIRMWARE)

ifneq (,$(wildcard $(DESTDIR)/etc/udev/rules.d))
  DYNFS:=yes
endif

ROOT_PREFIX:=

ASCIIDOC:=asciidoc
ASCIIDOC_CMD:=$(ASCIIDOC) -n -a toc -a toclevels=4

GENERATED_DOCS:=README.html

ifneq ($(wildcard .version),)
  DAHDIVERSION:=$(shell cat .version)
else
ifneq ($(wildcard .svn),)
  DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
endif
endif

all: modules

modules: prereq
ifeq (no,$(HAS_KSRC))
	@echo "You do not appear to have the sources for the $(KVERS) kernel installed."
	@exit 1
endif
	$(KMAKE) modules DAHDI_BUILD_ALL=$(DAHDI_BUILD_ALL)

include/dahdi/version.h: FORCE
	@DAHDIVERSION="${DAHDIVERSION}" build_tools/make_version_h > $@.tmp
	@if cmp -s $@.tmp $@ ; then :; else \
		mv $@.tmp $@ ; \
	fi
	@rm -f $@.tmp

prereq: include/dahdi/version.h firmware-loaders

stackcheck: checkstack modules
	./checkstack kernel/*.ko kernel/*/*.ko

install: all install-modules install-devices install-include install-firmware install-xpp-firm
	@echo "###################################################"
	@echo "###"
	@echo "### DAHDI installed successfully."
	@echo "### If you have not done so before, install the package"
	@echo "### dahdi-tools."
	@echo "###"
	@echo "###################################################"

uninstall: uninstall-modules uninstall-devices uninstall-include uninstall-firmware

install-modconf:
	build_tools/genmodconf $(BUILDVER) "$(ROOT_PREFIX)" "$(filter-out dahdi dahdi_dummy xpp dahdi_transcode dahdi_dynamic,$(BUILD_MODULES)) $(MODULE_ALIASES)"
	@if [ -d /etc/modutils ]; then \
		/sbin/update-modules ; \
	fi

install-xpp-firm:
	$(MAKE) -C drivers/dahdi/xpp/firmwares install

install-firmware:
ifeq ($(HOTPLUG_FIRMWARE),yes)
	$(MAKE) -C drivers/dahdi/firmware hotplug-install DESTDIR=$(DESTDIR) HOTPLUG_FIRMWARE=$(HOTPLUG_FIRMWARE)
endif

uninstall-firmware:
	$(MAKE) -C drivers/dahdi/firmware hotplug-uninstall DESTDIR=$(DESTDIR)

firmware-loaders:
	$(MAKE) -C drivers/dahdi/firmware firmware-loaders

install-include:
	for hdr in $(INST_HEADERS); do \
		install -D -m 644 include/dahdi/$$hdr $(DESTDIR)/usr/include/dahdi/$$hdr; \
	done
	-@rm -f $(DESTDIR)/usr/include/zaptel/*.h
	-@rmdir $(DESTDIR)/usr/include/zaptel

uninstall-include:
	for hdr in $(INST_HEADERS); do \
		rm -f $(DESTDIR)/usr/include/dahdi/$$hdr; \
	done
	-rmdir $(DESTDIR)/usr/include/dahdi

install-devices:
ifndef DYNFS
	mkdir -p $(DESTDIR)/dev/dahdi
	rm -f $(DESTDIR)/dev/dahdi/ctl
	rm -f $(DESTDIR)/dev/dahdi/channel
	rm -f $(DESTDIR)/dev/dahdi/pseudo
	rm -f $(DESTDIR)/dev/dahdi/timer
	rm -f $(DESTDIR)/dev/dahdi/transcode
	rm -f $(DESTDIR)/dev/dahdi/253
	rm -f $(DESTDIR)/dev/dahdi/252
	rm -f $(DESTDIR)/dev/dahdi/251
	rm -f $(DESTDIR)/dev/dahdi/250
	mknod $(DESTDIR)/dev/dahdi/ctl c 196 0
	mknod $(DESTDIR)/dev/dahdi/transcode c 196 250
	mknod $(DESTDIR)/dev/dahdi/timer c 196 253
	mknod $(DESTDIR)/dev/dahdi/channel c 196 254
	mknod $(DESTDIR)/dev/dahdi/pseudo c 196 255
	N=1; \
	while [ $$N -lt 250 ]; do \
		rm -f $(DESTDIR)/dev/dahdi/$$N; \
		mknod $(DESTDIR)/dev/dahdi/$$N c 196 $$N; \
		N=$$[$$N+1]; \
	done
else # DYNFS
	install -d $(DESTDIR)/etc/udev/rules.d
	build_tools/genudevrules > $(DESTDIR)/etc/udev/rules.d/dahdi.rules
	install -m 644 drivers/dahdi/xpp/xpp.rules $(DESTDIR)/etc/udev/rules.d/
endif

uninstall-devices:
ifndef DYNFS
	-rm -rf $(DESTDIR)/dev/dahdi
else # DYNFS
	rm -f $(DESTDIR)/etc/udev/rules.d/dahdi.rules
endif

install-modules: modules
ifndef DESTDIR
	@if modinfo zaptel > /dev/null 2>&1; then \
		echo -n "Removing Zaptel modules for kernel $(KVERS), please wait..."; \
		build_tools/uninstall-modules zaptel $(KVERS); \
		rm -rf /lib/modules/$(KVERS)/zaptel; \
		echo "done."; \
	fi
	build_tools/uninstall-modules dahdi $(KVERS)
endif
	$(KMAKE) INSTALL_MOD_PATH=$(DESTDIR) INSTALL_MOD_DIR=dahdi modules_install
	[ `id -u` = 0 ] && /sbin/depmod -a $(KVERS) || :

uninstall-modules:
ifdef DESTDIR
	@echo "Uninstalling modules is not supported with a DESTDIR specified."
	@exit 1
else
	@if modinfo dahdi > /dev/null 2>&1 ; then \
		echo -n "Removing DAHDI modules for kernel $(KVERS), please wait..."; \
		build_tools/uninstall-modules dahdi $(KVERS); \
		rm -rf /lib/modules/$(KVERS)/dahdi; \
		echo "done."; \
	fi
	[ `id -u` = 0 ] && /sbin/depmod -a $(KVERS) || :
endif

update:
	@if [ -d .svn ]; then \
		echo "Updating from Subversion..." ; \
		svn update | tee update.out; \
		rm -f .version; \
		if [ `grep -c ^C update.out` -gt 0 ]; then \
			echo ; echo "The following files have conflicts:" ; \
			grep ^C update.out | cut -b4- ; \
		fi ; \
		rm -f update.out; \
	else \
		echo "Not under version control";  \
	fi

clean:
ifneq (no,$(HAS_KSRC))
	$(KMAKE) clean
endif
	@rm -f $(GENERATED_DOCS)
	$(MAKE) -C drivers/dahdi/firmware clean

distclean: dist-clean

dist-clean: clean
	@rm -f include/dahdi/version.h
	@$(MAKE) -C drivers/dahdi/firmware dist-clean
	@rm -f drivers/dahdi/vpmadt032_loader/*.o_shipped

firmware-download:
	@$(MAKE) -C drivers/dahdi/firmware all

test:
	./test-script $(DESTDIR)/lib/modules/$(KVERS) dahdi

docs: $(GENERATED_DOCS)

README.html: README
	$(ASCIIDOC_CMD) -o $@ $<

.PHONY: distclean dist-clean clean all install devices modules stackcheck install-udev update install-modules install-include uninstall-modules firmware-download install-xpp-firm firmware-loaders

FORCE:

=== drivers/dahdi/firmware/Makefile ===
#
# DAHDI
# 
# Makefile for firmware downloading/installation
#
# Copyright (C) 2007-2009, Digium, Inc.
#
# Joshua Colp <jcolp@digium.com>
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

.PHONY: dist-clean clean all uninstall have_download install object-build hotplug-install hotplug-dirs hotplug-uninstall make_firmware_object firmware-loaders

OCT6114_064_VERSION:=1.05.01
OCT6114_128_VERSION:=1.05.01
TC400M_VERSION:=MR6.12
VPMADT032_VERSION:=1.17.0

FIRMWARE_URL:=http://downloads.digium.com/pub/telephony/firmware/releases

ALL_FIRMWARE=FIRMWARE-OCT6114-064 FIRMWARE-OCT6114-128 FIRMWARE-TC400M

# Firmware files should use the naming convention: dahdi-fw-<base name>-<sub name>-<version> or dahdi-fw-<base name>-<version>
# First example: dahdi-fw-oct6114-064-1.05.01
# This means this is version 1.05.01 of the oct6114-064 firmware
# Second example: dahdi-fw-tc400m-MR5.6
# This means this is version MR5.6 of the tc400m firmware

# Build a list of firmware package filenames we need
FIRMWARE:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064-$(OCT6114_064_VERSION).tar.gz)
FIRMWARE:=$(FIRMWARE:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128-$(OCT6114_128_VERSION).tar.gz)
FIRMWARE:=$(FIRMWARE:FIRMWARE-TC400M=dahdi-fw-tc400m-$(TC400M_VERSION).tar.gz)

FWLOADERS:=dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz

# Build a list of object files if hotplug will not be used
OBJECT_FILES:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064.o)
OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128.o)
OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-TC400M=dahdi-fw-tc400m.o)

# Force usage of wget, for now
DOWNLOAD=wget
WGET=wget

# If "fetch" is used, --continue is not a valid option.
ifeq ($(WGET),wget)
WGET_ARGS:=--continue
endif

all: $(FIRMWARE)

# Clean up any downloaded/extracted firmware packages
dist-clean: clean
	rm -f dahdi-fw-*.bin
	rm -f dahdi-fw-*.tar.gz
	rm -f dahdi-fwload-*.tar.gz
	rm -f make_firmware_object

# Clean up anything we built
clean:
	rm -f dahdi-fw-*.o

# Download and extract firmware tarballs
dahdi-fw-%.tar.gz:
	@if ( [ "$(HOTPLUG_FIRMWARE)" = "no" ] ) || ( [ -d $(DESTDIR)/usr/lib/hotplug/firmware ] && ! [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.$(subst .tar.gz,,$*) ] ) || ( [ -d $(DESTDIR)/lib/firmware ] && ! [ -f $(DESTDIR)/lib/firmware/.$(subst .tar.gz,,$*) ] ); then \
		echo "Attempting to download $@"; \
		if test ! -f $@; then $(DOWNLOAD) $(WGET_ARGS) $(FIRMWARE_URL)/$@; fi; \
		if test ! -f $@; then exit 1; fi; \
		(cat $@ | gzip -d | tar -xof -) \
	fi

firmware-loaders: $(FWLOADERS)

.PHONY: dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz
dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz:
	@if test ! -f $@; then echo "Attempting to download $@"; $(DOWNLOAD) $(WGET_ARGS) $(FIRMWARE_URL)/$@; fi; \
	if test ! -f $@; then exit 1; fi; \
	(cd ../../..; cat drivers/dahdi/firmware/$@ | gzip -d | tar -xof -) 

# Create object files suitable for linking against
object-build: $(FIRMWARE) $(OBJECT_FILES)

$(DESTDIR)/usr/lib/hotplug/firmware $(DESTDIR)/lib/firmware:
	mkdir -p $@

# Install all downloaded firmware images for hotplug usage
hotplug-install: $(DESTDIR)/usr/lib/hotplug/firmware $(DESTDIR)/lib/firmware $(FIRMWARE)
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-oct6114-064.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-oct6114-064.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-064-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION)
	@install -m 644 dahdi-fw-oct6114-064.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-064-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION)
else
	@echo "Firmware dahdi-fw-oct6114-064.bin is already installed with required version $(OCT6114_064_VERSION)"
endif
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-oct6114-128.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-oct6114-128.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-128-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION)
	@install -m 644 dahdi-fw-oct6114-128.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-128-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION)
else
	@echo "Firmware dahdi-fw-oct6114-128.bin is already installed with required version $(OCT6114_128_VERSION)"
endif
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-tc400m.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-tc400m.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-tc400m-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION)
	@install -m 644 dahdi-fw-tc400m.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-tc400m-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION)
else
	@echo "Firmware dahdi-fw-tc400m.bin is already installed with required version $(TC400M_VERSION)"
endif

# Uninstall any installed dahdi firmware images from hotplug firmware directories
hotplug-uninstall:
	if [ -d $(DESTDIR)/usr/lib/hotplug/firmware ]; then \
		rm -f $(DESTDIR)/usr/lib/hotplug/firmware/dahdi-fw-*.bin; \
		rm -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw*; \
	fi
	if [ -d $(DESTDIR)/lib/firmware ]; then \
		rm -f $(DESTDIR)/lib/firmware/dahdi-fw-*.bin; \
		rm -f $(DESTDIR)/lib/firmware/.dahdi-fw*; \
	fi

make_firmware_object: make_firmware_object.in ../dahdi-base.o
	@export BFDNAME=`LANG=C objdump -f ../dahdi-base.o | grep -e "dahdi-base.o:" | sed "s/.*file format \(.*\)/\1/"`; \
	 export BFDARCH=`LANG=C objdump -f ../dahdi-base.o | grep -e "architecture:" | sed "s/.*ture: \(.*\),.*/\1/"`; \
	 sed -e s/BFDNAME/$${BFDNAME}/ -e s/BFDARCH/$${BFDARCH}/ $< > $@
	@chmod +x $@

# Build object file of an oct6114 064 firmware image for linking
dahdi-fw-oct6114-064.o: dahdi-fw-oct6114-064-$(OCT6114_064_VERSION).tar.gz dahdi-fw-oct6114-064.bin make_firmware_object
	@echo Making firmware object file for dahdi-fw-oct6114-064.bin
	./make_firmware_object dahdi-fw-oct6114-064.bin $@

# Build object file of an oct6114 128 firmware image for linking
dahdi-fw-oct6114-128.o: dahdi-fw-oct6114-128-$(OCT6114_128_VERSION).tar.gz dahdi-fw-oct6114-128.bin make_firmware_object
	@echo Making firmware object file for dahdi-fw-oct6114-128.bin
	./make_firmware_object dahdi-fw-oct6114-128.bin $@

# Build object file of a TC400M firmware image for linking
dahdi-fw-tc400m.o: dahdi-fw-tc400m-$(TC400M_VERSION).tar.gz dahdi-fw-tc400m.bin make_firmware_object
	@echo Making firmware object file for dahdi-fw-tc400m.bin
	./make_firmware_object dahdi-fw-tc400m.bin $@

## dahdi-linux 2.2.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -128,8 +128,7 @@
 	for hdr in $(INST_HEADERS); do \
 		install -D -m 644 include/dahdi/$$hdr $(DESTDIR)/usr/include/dahdi/$$hdr; \
 	done
-	-@rm -f $(DESTDIR)/usr/include/zaptel/*.h
-	-@rmdir $(DESTDIR)/usr/include/zaptel
+	@rm -rf $(DESTDIR)/usr/include/zaptel
 
 uninstall-include:
 	for hdr in $(INST_HEADERS); do \

=== drivers/dahdi/firmware/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 OCT6114_064_VERSION:=1.05.01
 OCT6114_128_VERSION:=1.05.01
 TC400M_VERSION:=MR6.12
-VPMADT032_VERSION:=1.17.0
+VPMADT032_VERSION:=1.20.0
 
 FIRMWARE_URL:=http://downloads.digium.com/pub/telephony/firmware/releases

=== drivers/dahdi/xpp/firmwares/Makefile ===
# Install firmwares and initialization scripts for the Astribank
# drivers

FPGA_FW		= FPGA_FXS.hex FPGA_1141.hex FPGA_1151.hex FPGA_1161.hex
PIC_FW		= PIC_TYPE_1.hex PIC_TYPE_2.hex PIC_TYPE_3.hex PIC_TYPE_4.hex  
FIRMWARES	= USB_FW.hex $(FPGA_FW) $(PIC_FW)
PROTO_VER	= 30
SCRIPTS_BASE	= $(patsubst %,init_card_%_$(PROTO_VER),1 2 3 4)
SCRIPTS		= $(SCRIPTS_BASE:%=../%)
TARGET		= $(DESTDIR)/usr/share/dahdi

all:

clean:

install:
	mkdir -p $(TARGET)
	install $(SCRIPTS) $(TARGET)/
	install -m 644 ../XppConfig.pm $(FIRMWARES) $(TARGET)/

## dahdi-linux 2.3.0.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -38,6 +38,8 @@
   HAS_KSRC:=no
 endif
 
+CHECKSTACK=$(KSRC)/scripts/checkstack.pl
+
 # Set HOTPLUG_FIRMWARE=no to override automatic building with hotplug support
 # if it is enabled in the kernel.
 
@@ -45,6 +47,8 @@
   HOTPLUG_FIRMWARE:=$(shell if grep -q '^CONFIG_FW_LOADER=[ym]' $(KCONFIG); then echo "yes"; else echo "no"; fi)
 endif
 
+UDEV_DIR:=/etc/udev/rules.d
+
 MODULE_ALIASES:=wcfxs wctdm8xxp wct2xxp
 
 INST_HEADERS:=kernel.h user.h fasthdlc.h wctdm_user.h dahdi_config.h
@@ -52,10 +56,6 @@
 DAHDI_BUILD_ALL:=m
 
 KMAKE=$(MAKE) -C $(KSRC) SUBDIRS=$(PWD)/drivers/dahdi DAHDI_INCLUDE=$(PWD)/include DAHDI_MODULES_EXTRA="$(DAHDI_MODULES_EXTRA)" HOTPLUG_FIRMWARE=$(HOTPLUG_FIRMWARE)
-
-ifneq (,$(wildcard $(DESTDIR)/etc/udev/rules.d))
-  DYNFS:=yes
-endif
 
 ROOT_PREFIX:=
 
@@ -90,8 +90,8 @@
 
 prereq: include/dahdi/version.h firmware-loaders
 
-stackcheck: checkstack modules
-	./checkstack kernel/*.ko kernel/*/*.ko
+stackcheck: $(CHECKSTACK) modules
+	objdump -d drivers/dahdi/*.ko drivers/dahdi/*/*.ko | $(CHECKSTACK)
 
 install: all install-modules install-devices install-include install-firmware install-xpp-firm
 	@echo "###################################################"
@@ -137,40 +137,12 @@
 	-rmdir $(DESTDIR)/usr/include/dahdi
 
 install-devices:
-ifndef DYNFS
-	mkdir -p $(DESTDIR)/dev/dahdi
-	rm -f $(DESTDIR)/dev/dahdi/ctl
-	rm -f $(DESTDIR)/dev/dahdi/channel
-	rm -f $(DESTDIR)/dev/dahdi/pseudo
-	rm -f $(DESTDIR)/dev/dahdi/timer
-	rm -f $(DESTDIR)/dev/dahdi/transcode
-	rm -f $(DESTDIR)/dev/dahdi/253
-	rm -f $(DESTDIR)/dev/dahdi/252
-	rm -f $(DESTDIR)/dev/dahdi/251
-	rm -f $(DESTDIR)/dev/dahdi/250
-	mknod $(DESTDIR)/dev/dahdi/ctl c 196 0
-	mknod $(DESTDIR)/dev/dahdi/transcode c 196 250
-	mknod $(DESTDIR)/dev/dahdi/timer c 196 253
-	mknod $(DESTDIR)/dev/dahdi/channel c 196 254
-	mknod $(DESTDIR)/dev/dahdi/pseudo c 196 255
-	N=1; \
-	while [ $$N -lt 250 ]; do \
-		rm -f $(DESTDIR)/dev/dahdi/$$N; \
-		mknod $(DESTDIR)/dev/dahdi/$$N c 196 $$N; \
-		N=$$[$$N+1]; \
-	done
-else # DYNFS
-	install -d $(DESTDIR)/etc/udev/rules.d
-	build_tools/genudevrules > $(DESTDIR)/etc/udev/rules.d/dahdi.rules
-	install -m 644 drivers/dahdi/xpp/xpp.rules $(DESTDIR)/etc/udev/rules.d/
-endif
+	install -d $(DESTDIR)$(UDEV_DIR)
+	build_tools/genudevrules > $(DESTDIR)$(UDEV_DIR)/dahdi.rules
+	install -m 644 drivers/dahdi/xpp/xpp.rules $(DESTDIR)$(UDEV_DIR)/
 
 uninstall-devices:
-ifndef DYNFS
-	-rm -rf $(DESTDIR)/dev/dahdi
-else # DYNFS
-	rm -f $(DESTDIR)/etc/udev/rules.d/dahdi.rules
-endif
+	rm -f $(DESTDIR)$(UDEV_DIR)/dahdi.rules
 
 install-modules: modules
 ifndef DESTDIR
@@ -238,6 +210,9 @@
 README.html: README
 	$(ASCIIDOC_CMD) -o $@ $<
 
+dahdi-api.html: drivers/dahdi/dahdi-base.c
+	build_tools/kernel-doc --kernel $(KSRC) $^ >$@
+
 .PHONY: distclean dist-clean clean all install devices modules stackcheck install-udev update install-modules install-include uninstall-modules firmware-download install-xpp-firm firmware-loaders
 
 FORCE:

=== drivers/dahdi/firmware/Makefile ===
--- 
+++ 
@@ -3,12 +3,21 @@
 # 
 # Makefile for firmware downloading/installation
 #
-# Copyright (C) 2007-2009, Digium, Inc.
+# Copyright (C) 2007-2010, Digium, Inc.
 #
 # Joshua Colp <jcolp@digium.com>
 #
+#
+# See http://www.asterisk.org for more information about
+# the Asterisk project. Please do not directly contact
+# any of the maintainers of this project for assistance;
+# the project provides a web site, mailing lists and IRC
+# channels for your use.
+#
 # This program is free software, distributed under the terms of
-# the GNU General Public License
+# the GNU General Public License Version 2 as published by the
+# Free Software Foundation. See the LICENSE file included with
+# this program for more details.
 #
 
 .PHONY: dist-clean clean all uninstall have_download install object-build hotplug-install hotplug-dirs hotplug-uninstall make_firmware_object firmware-loaders
@@ -17,10 +26,11 @@
 OCT6114_128_VERSION:=1.05.01
 TC400M_VERSION:=MR6.12
 VPMADT032_VERSION:=1.20.0
+HX8_VERSION:=2.06
 
 FIRMWARE_URL:=http://downloads.digium.com/pub/telephony/firmware/releases
 
-ALL_FIRMWARE=FIRMWARE-OCT6114-064 FIRMWARE-OCT6114-128 FIRMWARE-TC400M
+ALL_FIRMWARE=FIRMWARE-OCT6114-064 FIRMWARE-OCT6114-128 FIRMWARE-TC400M FIRMWARE-HX8
 
 # Firmware files should use the naming convention: dahdi-fw-<base name>-<sub name>-<version> or dahdi-fw-<base name>-<version>
 # First example: dahdi-fw-oct6114-064-1.05.01
@@ -32,6 +42,7 @@
 FIRMWARE:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064-$(OCT6114_064_VERSION).tar.gz)
 FIRMWARE:=$(FIRMWARE:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128-$(OCT6114_128_VERSION).tar.gz)
 FIRMWARE:=$(FIRMWARE:FIRMWARE-TC400M=dahdi-fw-tc400m-$(TC400M_VERSION).tar.gz)
+FIRMWARE:=$(FIRMWARE:FIRMWARE-HX8=dahdi-fw-hx8-$(HX8_VERSION).tar.gz)
 
 FWLOADERS:=dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz
 
@@ -39,6 +50,7 @@
 OBJECT_FILES:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064.o)
 OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128.o)
 OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-TC400M=dahdi-fw-tc400m.o)
+OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-HX8=dahdi-fw-hx8.o)
 
 # Force usage of wget, for now
 DOWNLOAD=wget
@@ -120,6 +132,17 @@
 else
 	@echo "Firmware dahdi-fw-tc400m.bin is already installed with required version $(TC400M_VERSION)"
 endif
+ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-hx8-$(HX8_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-hx8-$(HX8_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
+	@echo "Installing dahdi-fw-hx8.bin to hotplug firmware directories"
+	@install -m 644 dahdi-fw-hx8.bin $(DESTDIR)/usr/lib/hotplug/firmware
+	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-hx8-*
+	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-hx8-$(HX8_VERSION)
+	@install -m 644 dahdi-fw-hx8.bin $(DESTDIR)/lib/firmware
+	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-hx8-*
+	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-hx8-$(HX8_VERSION)
+else
+	@echo "Firmware dahdi-fw-hx8.bin is already installed with required version $(HX8_VERSION)"
+endif
 
 # Uninstall any installed dahdi firmware images from hotplug firmware directories
 hotplug-uninstall:

=== debian/changelog ===
dahdi-linux (1:2.3.0.1+dfsg-2ubuntu2) natty; urgency=low

  * debian/patches/bkl_fix_ioctl: Do not ioctl when unlocked_ioctl is available.
    Previous behaviour was causing a dkms build failure. Patch cherry picked 
    from upstream commit (r9142). (LP: #731197)
  * debian/patches/drop_semaphores_as_mutexes: Use of semaphores as mutexes 
    feature was removed from the kernel, causing dkms build failure. Patch 
    cherry picked from upstream commit (r9464), with minor alterations.

 -- Dave Walker (Daviey) <DaveWalker@ubuntu.com>  Wed, 13 Apr 2011 10:56:26 +0100

dahdi-linux (1:2.3.0.1+dfsg-2ubuntu1) natty; urgency=low

  * Merge from Debian testing (Remaining changes):
    - debian/dahdi-dkms.install.in : add .version
    - debian/dkms.conf.in : do not 'make clean' after compile. We have to
      do this because the wanpipe (sangoma) drivers need Module.symvers.
    - debian/rules : cleanup dahdi-dkms.install and dkms.conf after build
    - debian/control: Change Maintainer
    - debian/control: Removed Uploaders field.
    - debian/control: Removed Debian Vcs-Svn entry and replaced with
      ubuntu-voip Vcs-Bzr, to reflect divergence in packages.
    - debian/control: Fix typo (right command is m-a a-i dahdi-source)
    - Import modifications by Javier Uruen Val <javi@warp.es>:
      - debian/system.conf
      - debian/modules
    - DKMS support:
      - debian/control: Added Depends to dahdi-linux (dahdi-dkms | dahdi-source)
      - debian/control: Add dkms package
      - debian/dahdi-dkms.install
      - debian/dahdi-dkms.postinst
      - debian/dahdi-dkms.prerm
      - debian/dahdi-linux.install
      - debian/rules: add code to automatically configure dkms.conf
      - debian/dkms.conf.in

  [ Stefan Lesicnik ]
  * debian/dkms.conf.in: Add () so make.log captures all output
  * debian/dkms.conf.in: Build dahdi_dummy as module to fix dkms build failure

 -- Stefan Lesicnik <stefan@lsd.co.za>  Thu, 11 Nov 2010 11:24:07 +0200

dahdi-linux (1:2.3.0.1+dfsg-2) unstable; urgency=medium

  [ Faidon Liambotis ]
  * Add myself to uploaders.

  [ Tzafrir Cohen ]
  * Disable mmx_auto for now (Closes: #593438).
  * dahdi_linux_extra: Re-apply zaphfc r7 (Closes: #598886).
  * Patch wcb4xxp_bn4s0e: missing PCI IDs for beroNet BN4S0e (Closes: #600839).

 -- Tzafrir Cohen <tzafrir@debian.org>  Wed, 20 Oct 2010 21:21:58 +0200

dahdi-linux (1:2.3.0.1+dfsg-1) unstable; urgency=low

  * New upstream version (Closes: #546319).
  * Patch no_dummy removed: merged upstream. 
  * Patch wcb4xxp_extra_trunk removed: merged upstream.
  * Patch chanmute: make it also explicitly disable the untested
    DAHDI_AUDIO_NOTIFY.
  * Patch oslec_include_2634: fix building with 2.6.34 (Closes: #586216).
  * Patches xpp_usb_buffer_2635, voicebus_sem_h_2635: Likewise for 2.6.35.
  * Patch dahdi_linux_extra: revert last fix to zaphfc.
  * Standards version 3.9.1 (no change needed).

 -- Tzafrir Cohen <tzafrir@debian.org>  Tue, 03 Aug 2010 03:58:11 +0300

dahdi-linux (1:2.2.1.1+dfsg-1) unstable; urgency=low

  * New upstream minor release.
  * Updated copyrights file.
  * Standards version 3.8.4: no change needed.
  * Patch wcb4xxp_extra_trunk: backport extra PCI IDs for wcb4xxp
    (more HFC-[248]S cards).
  * Switch to a @debian.org address.
  * Dpkg V3 format (it was quilt already). 
  * Remove lintian override that is no longer needed.
  * Patch dahdi_linux_extra: manually fix to remove a leading '---'.
  * dahdi-modules packages now depend on the linux-image versions. 
  * Other minor updates to the packaging of the dahdi-modules package.

 -- Tzafrir Cohen <tzafrir@debian.org>  Sun, 18 Apr 2010 17:14:02 +0300

dahdi-linux (1:2.2.1+dfsg-1ubuntu3) maverick; urgency=low

  * 2.6.35-build.patch:
    - fixes builds on 2.6.35 kernels. Fixed in debian 1:2.3.0.1+dfsg-1 
    (LP: #591375)

 -- Niall Creech <niallcreech@googlemail.com>  Fri, 17 Sep 2010 09:45:04 +0200

dahdi-linux (1:2.2.1+dfsg-1ubuntu2) lucid; urgency=low

   * Bug fixes:
    - debian/dahdi-dkms.install.in : add .version
    - debian/dkms.conf.in : do not 'make clean' after compile. We have to 
      do this because the wanpipe (sangoma) drivers need Module.symvers.
    - debian/rules : cleanup dahdi-dkms.install and dkms.conf after build
    - debian/control : add Depends gcc
    - debian/control : add wget and gawk (LP: #481566, LP: #444522, LP: #429510)

 -- Jean-Michel Dault <jmdault@revolutionlinux.com>  Sun, 07 Mar 2010 21:37:49 -0500

dahdi-linux (1:2.2.1+dfsg-1ubuntu1) lucid; urgency=low

  * Merge from debian pkg-voip
    * Changes from Debian:
    - debian/control: Change Maintainer
    - debian/control: Removed Uploaders field.
    - debian/control: Removed Debian Vcs-Svn entry and replaced with
        ubuntu-voip Vcs-Bzr, to reflect divergence in packages.
    - debian/control: Fix typo (right command is m-a a-i dahdi-source)
    - debian/rules: Fix typo (s/rules/rules.d/)
  * Import modifications by Javier Uruen Val <javi@warp.es>:
    - debian/system.conf
    - debian/modules
  * DKMS support:
    - debian/control: Added Depends to dahdi-linux (dahdi-dkms | dahdi-source)
    - debian/control: Add dkms package
    - debian/dahdi-dkms.install
    - debian/dahdi-dkms.postinst
    - debian/dahdi-dkms.prerm
    - debian/dahdi-linux.install
    - debian/rules: add code to automatically configure dkms.conf
    - debian/dkms.conf.in

  * From debian pkg-voip SVN:
  [ Tzafrir Cohen ]
  * New upstream release (Closes: #564739).
  * Dropped patch wcfxo_reset_fix: merged upstream.
  * Section name of dahdi-source: kernel
  * Also provide an example xpp.conf .
  * Patch uk_rotary (Closes: #546329). 
  * Override the bogus lintian warning for 'm-a a-i dahdi'
  * Remove some remaining Zaptel left-overs.
  * Replaced extra drivers and patches with huge patch dahdi_linux_extra
    (Closes: #564720).
  * Patch xpp_udev_rules_2632: fix XPP udev rules (Closes: #562024). 
  * Also copy the .version file, to make sure modules have versions. 


=== debian/control ===
Source: dahdi-linux
Section: comm
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7), bzip2, asciidoc
Standards-Version: 3.9.1
Homepage: http://www.asterisk.org/
Vcs-Bzr: http://launchpad.net/~ubuntu-voip/ubuntu-voip/dahdi-linux/

Package: dahdi-linux
Architecture: all
# Xorcom packages depend on dahdi-firmware. Debian zaptel will probably 
# just recommend it.
Depends: dahdi-dkms | dahdi-source, ${shlibs:Depends}, ${misc:Depends}, procps, fxload
Replaces: zaptel
Conflicts: zaptel
Description: DAHDI telephony interface - Linux userspace parts
 DAHDI (formly Zaptel) is an interface for telephony devices used by e.g. 
 the Asterisk PBX software. The dahdi-* packages provide the kernel 
 DAHDI kernel modules and their required setup environment.
 .
 This package includes the minimal Linux-specific userspace parts: udev 
 configuration, xpp initialization scripts.

Package: dahdi-source
Section: kernel
Architecture: all
Depends: ${misc:Depends}, debhelper (>> 4.0), module-assistant (>= 0.8.1), bzip2
Recommends: dahdi-linux
Description: DAHDI telephony interface - source code for kernel driver
 DAHDI (formly Zaptel) is an interface for telephony devices used by e.g. 
 the Asterisk PBX software. The dahdi-* packages provide the kernel 
 DAHDI kernel modules and their required setup environment, as well as
 basic headers for building DAHDI modules and utilities.
 .
 It is normally used to build kernel modules package: m-a a-i dahdi-source

Package: dahdi-dkms
Section: devel
Architecture: all
Depends: dkms, make, libc6-dev, gcc, wget, gawk
Recommends: dahdi-linux
Description: DAHDI telephony interface (dkms kernel driver)
 DAHDI (formly Zaptel) is an interface for telephony devices used by e.g.
 the Asterisk PBX software. The dahdi-* packages provide the kernel
 DAHDI kernel modules and their required setup environment.
 .
 The dkms package will automatically compile the driver for your current
 kernel version.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatibility version to use.
USE_BRISTUFF=0
export HOTPLUG_FIRMWARE=1

-include /usr/share/quilt/quilt.make

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif

## MODULE-ASSISTANT STUFF
# prefix of the target package name
PREFIX:=dahdi
SKPG:=$(PREFIX)-source
PACKAGE:=$(PREFIX)-modules
PACKAGE_SRC:=$(PREFIX)-linux
# modifieable for experiments or debugging m-a
MA_DIR ?= /usr/share/modass
# load generic variable handling
-include $(MA_DIR)/include/generic.make
# load default rules
-include $(MA_DIR)/include/common-rules.make

DEBVERSION:=$(shell head -n 1 debian/changelog \
		    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
DEB_BASE_VERSION:=$(shell echo $(DEBVERSION) | sed -e 's/^.*://' -e 's/-[0-9~.a-z]*$$//')
UPVERSION:=$(shell echo $(DEB_BASE_VERSION) | sed -e 's/[~+]dfsg\(~\|$$\)/\1/' -e 's/~\(rc\|beta\)/-\1/')

# For DKMS. Use the full release (e.g.: 2.2.1+dfsg-1ubuntu1)
CVERSION := $(shell dpkg-parsechangelog | grep '^Version:' | cut -d' ' -f2 | cut -d\: -f2)

UPFILENAME := $(PACKAGE_SRC)_$(UPVERSION).orig.tar.gz
FILENAME := $(PACKAGE_SRC)_$(DEB_BASE_VERSION).orig.tar.gz
URL := http://downloads.asterisk.org/pub/telephony/$(PACKAGE_SRC)/releases/$(PACKAGE_SRC)-$(UPVERSION).tar.gz

# If the makefile was properly-writen, there was a good separation 
# between kernel and userspace. As things stand now I'd like to work
# around problems with bilding stuff with HOSTCC by simply providing 
# the generated headers as part of the source:
GENERATED_SOURCES := include/dahdi/version.h

EXTRA_MODS=opvxa1200

ifneq (,$(filter-out powerpc m68k armeb mips,$(shell dpkg-architecture -qDEB_HOST_ARCH)))
EXTRA_MODS += wcopenpci
endif

EXTRA_SUBDIRS += zaphfc ../staging/echo
EXTRA_MODS += dahdi_echocan_oslec

MOD_ARGS=MODULES_EXTRA="$(EXTRA_MODS)" SUBDIRS_EXTRA="$(EXTRA_SUBDIRS)"

kdist_clean: clean-unpatched

kdist_config: prep-deb-files

binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_prep
	#cp -a $(CURDIR)/debian/generated/* .
	make $(MOD_ARGS) modules KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) 
	make $(MOD_ARGS) install-modules KERNELRELEASE=$(KVERS) DESTDIR=$(CURDIR)/debian/$(PKGNAME)
ifeq (2.6,$(shell echo $(KVERS) | cut -d. -f1-2))
	# The 2.6 modules are way too big. This is only in kernel 2.6
	find debian/$(PKGNAME)/lib/modules -name '*.ko' |xargs strip -g
	$(RM) -f debian/$(PKGNAME)/lib/modules/$(KVERS)/modules.*
endif
	dh_installmodules
	dh_installdebconf
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

## END OF M-A SECTION

build: patch build-stamp
build-stamp: 
	dh_testdir

	# For DKMS
	sed -e "s|#CVERSION#|$(CVERSION)|"   \
		debian/dkms.conf.in > debian/dkms.conf
	sed -e "s|#CVERSION#|$(CVERSION)|"   \
		debian/dahdi-dkms.install.in > debian/dahdi-dkms.install
	
	$(MAKE) docs
	for mod in $(BRISTUFF_MODULES); do for i in c h; do \
		ln -s $$mod/$$mod.$$i drivers/dahdi/$$mod.$$i; \
	done; done
	$(MAKE) $(GENERATED_SOURCES)
	touch $@

clean: clean-unpatched unpatch
clean-unpatched:
	dh_testdir
	dh_testroot
	rm -f *-stamp

	#Delete the generated dkms files
	rm -f debian/dahdi-dkms.install
	rm -f debian/dkms.conf
	
	# Delete the generated bristuff symlinks:
	$(RM) -f $(BRISTUFF_MODULES:%=%.[ch])
	# Add here commands to clean up after the build process.
	rm -f $(GENERATED_SOURCES)
	# * Makefile does not exist when running svn-buildpackage
	#   as the source tree is not there.
	# FIXME: This will fail with an ugly warning on the clean of the
	# modules build. However only fter the actuual clean.
	rm -f dahdi/include/version.h
	[ ! -f Makefile ] || $(MAKE) dist-clean || true
	dh_clean

TARPARDIR=$(CURDIR)/debian/tmp
TARDIR=$(TARPARDIR)/modules/$(PREFIX)
install: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	$(MAKE) install-include DESTDIR=$(CURDIR)/debian/$(SKPG)
	dh_install
	# driver source code
	mkdir -p $(TARDIR)/debian/generated
	cp Makefile $(TARDIR)/
	cp -p .version $(TARDIR)/
	for dir in build_tools firmware include drivers; do \
	  if [ -d $$dir ]; then cp -r $$dir $(TARDIR); fi; \
	done
	
	# Packaging infrastructure
	cp -r debian/rules debian/changelog debian/copyright\
	  debian/control debian/compat \
	  debian/control.modules.in \
	  $(TARDIR)/debian/
	
	tar cjf debian/$(SKPG)/usr/src/$(PREFIX).tar.bz2 \
	  -C $(TARPARDIR) modules
	dh_installudev --name=dahdi
	
# Build architecture-independent files here.
binary: install
	dh_testdir
	dh_testroot
	
	dh_installdocs
	dh_installchangelogs -i ChangeLog
	dh_installexamples -i
	dh_perl
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

print-version:
	@@echo "Debian version:          $(DEBVERSION)"
	@@echo "Upstream version:        $(UPVERSION)"

# For the record: updating openvox drivers:
# wget 'http://www.openvox.cn/viewvc/dahdi/trunk/opvxa1200.c?view=co' \
#  | sed -e '\r$//' >drivers/dahdi/opvxa1200.c
#
# Updating the zaphfc drivers:
#   rm -rf old new
#   mkdir -p old new/drivers/dahdi
#   svn export http://zaphfc.googlecode.com/svn/branches/2.2/zaphfc/ new/drivers/dahdi/zaphfc
#   diff -Npur  --no-timestamps old new >debian/patches/zaphfc
#   rm -rf old new

TARBALL_DIR=../tarballs/$(PACKAGE_SRC)-$(UPVERSION).tmp
get-orig-source:
	@@dh_testdir
	@@[ -d ../tarballs/. ]||mkdir -p ../tarballs
	@@echo Downloading $(UPFILENAME) from $(URL) ...
	@@wget  -nv -T10 -t3 --verbose -O ../tarballs/$(UPFILENAME) $(URL)
	@@echo Repacking as DFSG-free...
	@@mkdir -p $(TARBALL_DIR)/
	@@cd $(TARBALL_DIR) ; \
	tar xfz ../$(UPFILENAME)
	@@rm -rf $(TARBALL_DIR)/$(PACKAGE_SRC)-$(UPVERSION)/drivers/dahdi/xpp/firmwares/*.hex
	@@cd $(TARBALL_DIR) ; \
	tar cfz ../$(FILENAME) *
	@@echo Cleaning up...
	@@$(RM) -rf $(TARBALL_DIR)/
	@@$(RM) -f ../tarballs/$(UPFILENAME)

.PHONY: build clean binary install configure patch unpatch

## dahdi-linux 2.4.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 DAHDI_BUILD_ALL:=m
 
-KMAKE=$(MAKE) -C $(KSRC) SUBDIRS=$(PWD)/drivers/dahdi DAHDI_INCLUDE=$(PWD)/include DAHDI_MODULES_EXTRA="$(DAHDI_MODULES_EXTRA)" HOTPLUG_FIRMWARE=$(HOTPLUG_FIRMWARE)
+KMAKE=+$(MAKE) -C $(KSRC) SUBDIRS=$(PWD)/drivers/dahdi DAHDI_INCLUDE=$(PWD)/include DAHDI_MODULES_EXTRA="$(DAHDI_MODULES_EXTRA)" HOTPLUG_FIRMWARE=$(HOTPLUG_FIRMWARE)
 
 ROOT_PREFIX:=
 
@@ -69,6 +69,10 @@
 else
 ifneq ($(wildcard .svn),)
   DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
+else
+ifneq ($(wildcard .git),)
+  DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
+endif
 endif
 endif

=== drivers/dahdi/firmware/Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 OCT6114_064_VERSION:=1.05.01
 OCT6114_128_VERSION:=1.05.01
 TC400M_VERSION:=MR6.12
-VPMADT032_VERSION:=1.20.0
+VPMADT032_VERSION:=1.25.0
 HX8_VERSION:=2.06
 
 FIRMWARE_URL:=http://downloads.digium.com/pub/telephony/firmware/releases
@@ -80,7 +80,7 @@
 		echo "Attempting to download $@"; \
 		if test ! -f $@; then $(DOWNLOAD) $(WGET_ARGS) $(FIRMWARE_URL)/$@; fi; \
 		if test ! -f $@; then exit 1; fi; \
-		(cat $@ | gzip -d | tar -xof -) \
+		(cat $@ | gzip -d | tar --no-same-owner -xf -) \
 	fi
 
 firmware-loaders: $(FWLOADERS)
@@ -89,7 +89,7 @@
 dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz:
 	@if test ! -f $@; then echo "Attempting to download $@"; $(DOWNLOAD) $(WGET_ARGS) $(FIRMWARE_URL)/$@; fi; \
 	if test ! -f $@; then exit 1; fi; \
-	(cd ../../..; cat drivers/dahdi/firmware/$@ | gzip -d | tar -xof -) 
+	(cd ../../..; cat drivers/dahdi/firmware/$@ | gzip -d | tar --no-same-owner -xf -)
 
 # Create object files suitable for linking against
 object-build: $(FIRMWARE) $(OBJECT_FILES)

=== debian/changelog ===
dahdi-linux (1:2.4.1+dfsg-1ubuntu2) oneiric; urgency=low

  * debian/patches/define_spinlock: Fix DKMS FTBFS, move test for
    DEFINE_SPINLOCK into include/dahdi/kernel.h. Cherry picked from upstream
    commit (r9411)

 -- Adam Gandelman <adam.gandelman@canonical.com>  Tue, 24 May 2011 11:21:53 -0700

dahdi-linux (1:2.4.1+dfsg-1ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable (Remaining changes):
    - debian/dahdi-dkms.install.in : add .version
    - debian/rules : cleanup dahdi-dkms.install and dkms.conf after build
    - debian/control: Fix typo (right command is m-a a-i dahdi-source)
    - Import modifications by Javier Uruen Val <javi@warp.es>:
      - debian/system.conf
      - debian/modules
    - DKMS support:
      - debian/control: Added Depends to dahdi-linux (dahdi-dkms | dahdi-source)
      - debian/control: Add dkms package
      - debian/dahdi-dkms.install
      - debian/dahdi-dkms.postinst
      - debian/dahdi-dkms.prerm
      - debian/dahdi-linux.install
      - debian/rules: add code to automatically configure dkms.conf
      - debian/dkms.conf.in

 -- Adam Gandelman <adam.gandelman@canonical.com>  Thu, 19 May 2011 15:15:46 -0700

dahdi-linux (1:2.4.1+dfsg-1) unstable; urgency=low

  * New Upstream release.
    - Patch uk_rotary dropped: merged upstream.
    - Patch oslec_include_2634 dropped: merged upstream. 
    - Patch xpp_usb_buffer_2635 dropped: merged upstream.
    - Patch voicebus_sem_h_2635 dropped: merged upstream.
  * dahdi_linux_extra now includes AP400 drivers (Closes: #582095).
  * Patch oslec_auto: Makes adding OSLEC less painful.
    - But for now it requires manually editing patch dahdi_linux_extra.

 -- Tzafrir Cohen <tzafrir@debian.org>  Mon, 07 Mar 2011 12:01:55 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,13 @@
 Section: comm
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>, Faidon Liambotis <paravoid@debian.org>
 XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Build-Depends: debhelper (>= 7), bzip2, asciidoc
 Standards-Version: 3.9.1
 Homepage: http://www.asterisk.org/
-Vcs-Bzr: http://launchpad.net/~ubuntu-voip/ubuntu-voip/dahdi-linux/
+Vcs-Svn: svn://svn.debian.org/pkg-voip/dahdi-linux/trunk/
+Vcs-Browser: http://svn.debian.org/wsvn/pkg-voip/dahdi-linux/?op=log
 
 Package: dahdi-linux
 Architecture: all

## dahdi-linux 2.5.0.1%2Bdfsg

=== debian/changelog ===
dahdi-linux (1:2.5.0.1+dfsg-1ubuntu4~14.04.4) trusty; urgency=low

  * d/p/kernel-v3-17-compat.patch, d/p/kernel-v3-18-compat.patch, and
    d/p/kernel-v3-19-compat.patch:
    Backport compat code to allow compilation of latest HWE (3.19) kernel
    in Trusty/14.04 (LP: #1499436).

 -- Stefan Bader <stefan.bader@canonical.com>  Tue, 29 Sep 2015 09:57:46 -0500

dahdi-linux (1:2.5.0.1+dfsg-1ubuntu4~14.04.3) trusty; urgency=low

  * debian/tests: Add special dep-8 test code as the generic testing
    fails because one module (echo.ko) is compiled but not installed
    since the kernel ships the same version (this has been fixed in
    newer packaging) (LP: #1497982).

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 21 Sep 2015 10:42:43 -0500

dahdi-linux (1:2.5.0.1+dfsg-1ubuntu4~14.04.2) trusty; urgency=low

  * debian/dkms.conf.in: Expose the target kernel version in a variable that
    is actually heeded by the make file. And also pass it in on every
    invokation of make (LP: #790558).
  * debian/patches/kernel-v3-11-compat.patch: Carried forward reworked
    version from Precise which unbreaks compiling on kernel <3.10
    (LP: #1336253).

 -- Stefan Bader <stefan.bader@canonical.com>  Tue, 09 Dec 2014 18:45:24 +0100

dahdi-linux (1:2.5.0.1+dfsg-1ubuntu4~14.04.1) trusty; urgency=low

  * Cherry-picking compat patches to support kernel versions up to 3.16
    (LP: #1336253)

 -- Stefan Bader <stefan.bader@canonical.com>  Fri, 14 Nov 2014 10:55:58 +0100

dahdi-linux (1:2.5.0.1+dfsg-1ubuntu3) saucy; urgency=low

  * Fix compile issues with 3.11 kernel

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 05 Aug 2013 13:39:27 +0100

dahdi-linux (1:2.5.0.1+dfsg-1ubuntu2) precise; urgency=low

  * Fix compile issues with 3.2 kernel (LP: #928499)

 -- Paul Belanger <paul.belanger@polybeacon.com>  Fri, 10 Feb 2012 10:07:30 +0000

dahdi-linux (1:2.5.0.1+dfsg-1ubuntu1) precise; urgency=low

  * Merge from Debian testing (LP: #879743). Remaining changes:
    - debian/dahdi-dkms.install.in : add .version
    - Import modifications by Javier Uruen Val <javi@warp.es>:
      - debian/system.conf
      - debian/modules
    - DKMS support:
      - debian/control: Added Depends to dahdi-linux (dahdi-dkms | dahdi-source)
      - debian/control: Add dkms package
      - debian/dahdi-dkms.install
      - debian/dahdi-dkms.postinst
      - debian/dahdi-dkms.prerm
      - debian/dahdi-linux.install
      - debian/rules: add code to automatically configure dkms.conf
      - debian/dkms.conf.in
  * Dropped changes:
    - debian/control: Fix typo (right command is m-a a-i dahdi-source)
    - debian/patches/define_spinlock: Fixed upstream
  * debian/rules: Debian moved to dh, re-add code to automatically configure
    dkms.conf
  * debian/dkms.conf.in: update to reflect dahdi-linux-extra patch update
    (opvxa1200's new  location (subdir) and to include ap400 and opvxd115)
  * debian/patches/zaphfc_d_channel_fix.patch: Correct typo in zaphfc module
    until fix gets synced into dahdi-linux-extra patch in Debian (LP: #612091)

 -- Adam Gandelman <adamg@canonical.com>  Fri, 21 Oct 2011 17:32:09 -0700

dahdi-linux (1:2.5.0.1+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #639702).
    - Patch wcb4xxp_bn4s0e removed: merged upstream.
    - Patch define_spinlock removed: merged upstream.
    - Patch dahdi-linux-extra updated.
  * Updated dahdi-linux-extra:
    - "Upstream" is now a complete git mirror.
    - Actually include ap400 in the list of modules to build.
    - Updated OpenVox drivers: opvxa1200 is a subdirectory 
    - Updated OpenVox drivers: opvxd115 added (digital cards).
  * Patch define_spinlock: include a (slightly big) build fix from upstream.
  * Standards version 3.9.2 (no change needed).
  * Switch to dh.
  * Patch notest: Remove a bogus upstream 'test' target.
  * Lintian override for an odd interpteter a dummy kernel module init script. 
  * Dahdi udev rules are now named 'dahdi-linux.conf'.
  * Patch xpp_fix_2fxs6fxo: bugfix for Xorcom 2FXX6FXO module code.

 -- Tzafrir Cohen <tzafrir@debian.org>  Sun, 25 Sep 2011 22:58:17 +0300

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>, Faidon Liambotis <paravoid@debian.org>
 XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
-Build-Depends: debhelper (>= 7), bzip2, asciidoc
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>=  7.0.50~), bzip2, asciidoc
+Standards-Version: 3.9.2
 Homepage: http://www.asterisk.org/
 Vcs-Svn: svn://svn.debian.org/pkg-voip/dahdi-linux/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/pkg-voip/dahdi-linux/?op=log
